import { createRequire } from 'module';
import { visit } from 'unist-util-visit';
import { toString } from 'hast-util-to-string';

const __require = createRequire(import.meta.url);
//@ts-ignore
const ClassList = __require("hast-util-class-list");
function classList(node) {
    return ClassList(node);
}
const rehypePrismDiff = () => {
    return (tree) => {
        visit(tree, 'element', (node, _index, parent) => {
            if (!parent || parent.tagName !== 'pre' || !('tagName' in node) || node.tagName !== 'code') {
                return;
            }
            let meta = node.data && node.data.meta ? node.data.meta : '';
            if (!meta.toLowerCase().includes('diff'.toLowerCase()))
                return;
            classList(node).add('code-diff');
            node.children.forEach((line) => {
                if (line.type !== 'element')
                    return;
                const lineString = toString(line);
                if (lineString.substring(0, 1) === '-') {
                    classList(line).add(`diff-deleted`);
                }
                else if (lineString.substring(0, 1) === '+') {
                    classList(line).add(`diff-inserted`);
                }
                else if (lineString.substring(0, 1) === '!') {
                    classList(line).add(`diff-warn`);
                }
                else if (lineString.substring(0, 1) === '#') {
                    classList(line).add(`diff-comment`);
                }
            });
        });
    };
};

export { rehypePrismDiff as default };
//# sourceMappingURL=index.js.map
